import React, { ReactElement, ReactNode } from 'react';
import { StyleProp, TextStyle, ViewStyle } from 'react-native';
export type ButtonProps = {
    LeftIcon?: ReactElement;
    RightIcon?: ReactElement;
    children: ReactNode;
    color?: 'primary' | 'secondary' | 'positive' | 'negative';
    disabled?: boolean;
    fullWidth?: boolean;
    onClick?: (e?: any) => void | Promise<void>;
    ripple?: {
        color?: string;
    };
    size?: 'sm' | 'md' | 'lg' | 'xl';
    style?: {
        container?: StyleProp<ViewStyle>;
        text?: StyleProp<TextStyle>;
    };
    type?: 'button' | 'submit';
    variant?: 'contained' | 'outlined' | 'text';
};
export declare const Button: React.FC<ButtonProps>;
