"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWeekRange = exports.getStartOf = exports.getWeeksCount = exports.getMonday = void 0;
const date_fns_1 = require("date-fns");
const getMonday = (date) => {
    date = new Date(date);
    const day = date.getDay();
    const diff = date.getDate() - day + (day == 0 ? -6 : 1);
    return new Date(new Date(date.setDate(diff)).setHours(0, 0, 0, 0));
};
exports.getMonday = getMonday;
const getWeeksCount = (start, end) => Math.round((end.getTime() - start.getTime()) / 1000 / 60 / 60 / 24 / 7);
exports.getWeeksCount = getWeeksCount;
const getStartOf = (startOf, weekOfMonth) => {
    const startOfFirstMonthWeek = (0, exports.getMonday)(startOf);
    const startOfYear = new Date(startOf.getFullYear(), 0, 1);
    const startOfFirstYearWeek = (0, exports.getMonday)(startOfYear);
    const weekOfYear = (0, exports.getWeeksCount)(startOfFirstYearWeek, startOfFirstMonthWeek) + 1 + weekOfMonth;
    return (0, date_fns_1.setWeek)(startOfFirstMonthWeek, weekOfYear, { weekStartsOn: 1 });
};
exports.getStartOf = getStartOf;
const getWeekRange = (date) => [
    (0, date_fns_1.startOfWeek)(date, { weekStartsOn: 1 }),
    (0, date_fns_1.endOfWeek)(date, { weekStartsOn: 1 }),
];
exports.getWeekRange = getWeekRange;
