"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldMessage = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const FieldMessage = ({ style, message, color, size, }) => {
    if (!message) {
        return null;
    }
    return (react_1.default.createElement(FieldMessageText, { color: color, size: size, style: [style] }, message));
};
exports.FieldMessage = FieldMessage;
const FieldMessageText = native_1.default.Text(({ theme, color, size }) => {
    return {
        paddingTop: 3,
        paddingLeft: 2,
        paddingBottom: 2,
        fontFamily: theme.fontFamily,
        color: theme.palette[color].dark,
        fontSize: theme.fontSize[size] - 2,
    };
});
