import { FC, ReactNode } from 'react';
import { PressableProps, StyleProp, ViewStyle } from 'react-native';
export type GridProps = {
    children: ReactNode;
    cols?: Partial<Record<'xs' | 'sm' | 'md' | 'lg' | 'xl', number>>;
    fill?: boolean;
    layout?: Partial<Record<'xs' | 'sm' | 'md' | 'lg' | 'xl', (number | string)[]>>;
    style?: {
        cell?: StyleProp<ViewStyle>;
        row?: StyleProp<ViewStyle>;
    };
} & Omit<ViewStyle, 'direction'> & Omit<PressableProps, 'style'>;
export declare const Grid: FC<GridProps>;
