"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Label = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const Label = ({ children, style, size = 'sm', disabled, }) => {
    return (react_1.default.createElement(LabelText, { disabled: disabled, size: size, style: [style] }, children));
};
exports.Label = Label;
const LabelText = native_1.default.Text(({ theme, disabled, size }) => {
    return Object.assign({ color: theme.palette.text.main, fontFamily: theme.fontFamily, paddingLeft: 2, paddingBottom: 4, fontSize: theme.fontSize[size] }, (disabled && {
        color: theme.palette.disabled,
    }));
});
