"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RippleEffect = void 0;
const react_1 = __importStar(require("react"));
const react_native_gesture_handler_1 = require("react-native-gesture-handler");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
exports.RippleEffect = (0, react_1.forwardRef)(({ duration = 500, opacity = 0.8, color = 'white', children, style, disabled, }, ref) => {
    const centerX = (0, react_native_reanimated_1.useSharedValue)(0);
    const centerY = (0, react_native_reanimated_1.useSharedValue)(0);
    const scale = (0, react_native_reanimated_1.useSharedValue)(0);
    const width = (0, react_native_reanimated_1.useSharedValue)(0);
    const height = (0, react_native_reanimated_1.useSharedValue)(0);
    const rippleOpacity = (0, react_native_reanimated_1.useSharedValue)(opacity);
    const tapGestureEvent = react_native_gesture_handler_1.Gesture.Tap()
        .enabled(!disabled)
        .runOnJS(true)
        .onBegin((tapEvent) => {
        scale.value = 0;
        centerX.value = tapEvent.x;
        centerY.value = tapEvent.y;
        rippleOpacity.value = opacity;
        (0, react_native_reanimated_1.runOnUI)(() => {
            const layout = (0, react_native_reanimated_1.measure)(ref);
            width.value = layout.width;
            height.value = layout.height;
        })();
        scale.value = (0, react_native_reanimated_1.withTiming)(1, { duration: duration });
        rippleOpacity.value = (0, react_native_reanimated_1.withTiming)(0, { duration: duration });
    })
        .onEnd(() => {
        rippleOpacity.value = (0, react_native_reanimated_1.withTiming)(0, { duration: duration });
    });
    const animatedStyle = (0, react_native_reanimated_1.useAnimatedStyle)(() => {
        const circleRadius = width.value > height.value ? width.value : height.value * 2;
        const translateX = centerX.value - circleRadius;
        const translateY = centerY.value - circleRadius;
        return {
            width: circleRadius * 2,
            height: circleRadius * 2,
            borderRadius: circleRadius,
            opacity: rippleOpacity.value,
            zIndex: -1,
            backgroundColor: color,
            position: 'absolute',
            top: 0,
            left: 0,
            transform: [
                { translateX },
                { translateY },
                {
                    scale: scale.value,
                },
            ],
        };
    }, [centerX, centerY, width, height, rippleOpacity, scale]);
    return (react_1.default.createElement(react_native_gesture_handler_1.GestureDetector, { gesture: tapGestureEvent },
        react_1.default.createElement(react_native_reanimated_1.default.View, { style: [
                {
                    overflow: 'hidden',
                },
                style === null || style === void 0 ? void 0 : style.container,
            ] },
            react_1.default.createElement(react_native_reanimated_1.default.View, { style: animatedStyle }),
            children)));
});
exports.RippleEffect.displayName = 'RippleEffect';
