"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useToaster = exports.showToaster = exports.ToasterProvider = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const DefaultTimeout = 6 * 1000;
const timeouts = [];
const ToasterContext = (0, react_1.createContext)({
    toasters: {},
    open: () => { },
});
const ToasterProvider = ({ children }) => {
    const [toasters, setToasters] = (0, react_1.useState)({});
    const autoHide = (toaster) => {
        var _a;
        const { id } = toaster;
        setToasters(Object.assign(Object.assign({}, toasters), { [id]: toaster }));
        timeouts[id] = setTimeout(() => {
            setToasters((0, ramda_1.omit)([id], toasters));
        }, (_a = toaster.timeout) !== null && _a !== void 0 ? _a : DefaultTimeout);
    };
    (0, react_1.useEffect)(() => () => {
        Object.keys(timeouts).forEach((timeoutId) => {
            clearTimeout(timeouts[timeoutId]);
        });
    }, []);
    (0, react_1.useEffect)(() => {
        window.addEventListener('showToaster', (e) => {
            if (e.detail)
                autoHide(e.detail);
        });
    }, []);
    const value = (0, react_1.useMemo)(() => ({
        toasters,
        open: autoHide,
    }), [toasters]);
    return react_1.default.createElement(ToasterContext.Provider, { value: value }, children);
};
exports.ToasterProvider = ToasterProvider;
const showToaster = (toaster) => {
    window.dispatchEvent(new CustomEvent('showToaster', { detail: toaster }));
};
exports.showToaster = showToaster;
const useToaster = () => {
    const { open, toasters } = (0, react_1.useContext)(ToasterContext);
    return {
        toasters,
        showToaster: open,
    };
};
exports.useToaster = useToaster;
