"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Typography = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const Typography = ({ children, size = 'text' }) => {
    return react_1.default.createElement(TypographyText, { size: size }, children);
};
exports.Typography = Typography;
const TypographyText = native_1.default.Text(({ theme }) => {
    return {
        fontFamily: theme.fontFamily,
    };
}, ({ size, theme }) => {
    switch (size) {
        case 'h1': {
            return {
                fontSize: theme.fontSize['xxxl'],
            };
        }
        case 'h2': {
            return {
                fontSize: theme.fontSize['xxl'],
            };
        }
        case 'h3': {
            return {
                fontSize: theme.fontSize['xl'],
            };
        }
        case 'h4': {
            return {
                fontSize: theme.fontSize['lg'],
            };
        }
        case 'text': {
            return {
                fontSize: theme.fontSize['md'],
            };
        }
        case 'small': {
            return {
                fontSize: theme.fontSize['sm'],
            };
        }
        default: {
            return {};
        }
    }
});
