"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Alert = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const Stack_1 = require("@procyon/components/Stack");
const Ban_1 = require("@procyon/icons/Ban");
const CheckCheck_1 = require("@procyon/icons/CheckCheck");
const Info_1 = require("@procyon/icons/Info");
const Theme_1 = require("@procyon/styles/Theme");
const Alert = ({ color = 'secondary', title, Icon, children }) => {
    const { theme } = (0, Theme_1.useTheme)();
    return (react_1.default.createElement(MessageContainer, { "aria-label": "message", color: color },
        react_1.default.createElement(Stack_1.Stack, { direction: "row", gap: 10, alignItems: title ? 'flex-start' : 'center' },
            Icon !== undefined ? (Icon) : color === 'positive' ? (react_1.default.createElement(CheckCheck_1.CheckCheckIcon, { strokeWidth: 1, color: theme.palette.positive.dark })) : color === 'negative' ? (react_1.default.createElement(Ban_1.BanIcon, { strokeWidth: 1, color: theme.palette.negative.dark })) : (react_1.default.createElement(Info_1.InfoIcon, { strokeWidth: 1, color: theme.palette[color].dark })),
            react_1.default.createElement(react_native_1.View, null,
                title && react_1.default.createElement(MessageTitle, { color: color }, title),
                react_1.default.createElement(MessageText, null, children)))));
};
exports.Alert = Alert;
const MessageContainer = (0, native_1.default)(react_native_1.View)(({ theme, color }) => {
    return {
        backgroundColor: theme.palette[color].light,
        borderRadius: theme.rounded.small,
        padding: theme.spacing.lg,
        minWidth: 200,
    };
});
const MessageTitle = native_1.default.Text(({ theme, color }) => {
    return {
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSize.md,
        color: theme.palette[color].dark,
        marginBottom: theme.spacing.md,
        fontWeight: 'bold',
    };
});
const MessageText = native_1.default.Text(({ theme }) => {
    return {
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSize.sm,
    };
});
