"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Button = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importStar(require("@emotion/native"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const values_js_1 = __importDefault(require("values.js"));
const RippleEffect_1 = require("@procyon/components/RippleEffect");
const Stack_1 = require("@procyon/components/Stack");
const Theme_1 = require("@procyon/styles/Theme");
const useMediaQuery_1 = require("@procyon/styles/useMediaQuery");
const color_1 = require("@procyon/styles/utils/color");
const Button = (props) => {
    const { disabled, onClick, color = 'primary', size = 'md', children, variant = 'contained', fullWidth, style, LeftIcon, RightIcon, ripple, } = props;
    const rippleAnimateRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const [hover, setHover] = (0, react_1.useState)(false);
    const mq = (0, useMediaQuery_1.useMediaQuery)();
    const { theme } = (0, Theme_1.useTheme)();
    const rippleColor = (0, react_1.useMemo)(() => {
        if (ripple === null || ripple === void 0 ? void 0 : ripple.color)
            return ripple.color;
        const val = theme.palette[color].main;
        if ((0, color_1.isDark)(val)) {
            return new values_js_1.default(val).tint(30).rgbString();
        }
        else {
            return new values_js_1.default(val).shade(30).rgbString();
        }
    }, [color]);
    const buttonColor = (0, react_1.useMemo)(() => {
        if (variant === 'contained') {
            return (0, color_1.isDark)(theme.palette[color].main)
                ? theme.palette[color].light
                : theme.palette[color].dark;
        }
        if (variant === 'outlined' || variant === 'text') {
            return theme.palette[color].dark;
        }
        if (disabled) {
            return theme.palette.disabled;
        }
    }, [color, variant, disabled]);
    const LeftIconComponent = LeftIcon !== null && LeftIcon !== void 0 ? LeftIcon : null;
    const RightIconComponent = RightIcon !== null && RightIcon !== void 0 ? RightIcon : null;
    return (react_1.default.createElement(ButtonContainer, { variant: variant, "aria-label": "button", color: color, onPress: (...args) => onClick === null || onClick === void 0 ? void 0 : onClick(...args), hover: hover, fullWidth: fullWidth || (fullWidth === undefined && mq === 'xs'), onHoverIn: () => setHover(true), onHoverOut: () => setHover(false), style: [style === null || style === void 0 ? void 0 : style.container], disabled: disabled, collapsable: false, ref: rippleAnimateRef },
        react_1.default.createElement(RippleEffect_1.RippleEffect, { ref: rippleAnimateRef, disabled: disabled, color: rippleColor, style: {
                container: [
                    (0, native_1.css)({
                        paddingHorizontal: theme.spacing.lg,
                        borderRadius: theme.rounded.small,
                        alignItems: 'center',
                    }),
                    style === null || style === void 0 ? void 0 : style.container,
                ],
            } },
            react_1.default.createElement(Stack_1.Stack, { direction: "row", gap: 1, alignItems: "center" },
                LeftIconComponent && (react_1.default.createElement(LeftIconComponent.type, Object.assign({}, LeftIconComponent.props, { color: buttonColor, size: theme.iconSize[size] }))),
                react_1.default.createElement(ButtonText, { variant: variant, size: size, style: [{ color: buttonColor }, style === null || style === void 0 ? void 0 : style.text], disabled: disabled }, children),
                RightIconComponent && (react_1.default.createElement(RightIconComponent.type, Object.assign({}, RightIconComponent.props, { color: buttonColor })))))));
};
exports.Button = Button;
const ButtonContainer = native_1.default.Pressable(({ theme }) => ({
    borderRadius: theme.rounded.small,
    backgroundColor: 'transparent',
    justifyContent: 'center',
}), ({ theme, variant, color, hover, disabled, fullWidth }) => (Object.assign(Object.assign(Object.assign(Object.assign({}, (!fullWidth && Object.assign({}, (react_native_1.Platform.OS === 'web'
    ? {
        width: 'fit-content',
    }
    : {
        display: 'flex',
        alignSelf: 'flex-start',
    })))), (variant === 'contained'
    ? Object.assign(Object.assign(Object.assign({ backgroundColor: theme.palette[color].main }, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).shade(5).rgbString(),
    })), (color === 'secondary' && Object.assign({ backgroundColor: theme.palette.secondary.light }, (hover && {
        backgroundColor: new values_js_1.default(theme.palette.secondary.light)
            .shade(5)
            .rgbString(),
    })))), (disabled && {
        backgroundColor: new values_js_1.default(theme.palette.background.main)
            .tint(60)
            .rgbString(),
    })) : {})), (variant === 'outlined'
    ? Object.assign(Object.assign({ borderWidth: 2, borderColor: theme.palette[color].main }, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).tint(90).rgbString(),
    })), (disabled && {
        borderColor: new values_js_1.default(theme.palette.background.main).tint(60).rgbString(),
    })) : {})), (variant === 'text'
    ? Object.assign({}, (hover && {
        backgroundColor: new values_js_1.default(theme.palette[color].main).tint(90).rgbString(),
    })) : {}))));
const ButtonText = native_1.default.Text(({ theme, size }) => ({
    fontFamily: theme.fontFamily,
    padding: theme.spacing[size],
    fontSize: theme.fontSize[size],
    fontWeight: 'normal',
    userSelect: 'none',
    textTransform: 'uppercase',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center',
    gap: 4,
}));
