"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ButtonGroup = void 0;
const react_1 = __importStar(require("react"));
const native_1 = require("@emotion/native");
const react_native_1 = require("react-native");
const Theme_1 = require("@procyon/styles/Theme");
const nil_1 = require("@procyon/utils/nil");
exports.ButtonGroup = (0, react_1.forwardRef)((_a, ref) => {
    var { children, style, color = 'primary', variant = 'contained' } = _a, buttonProps = __rest(_a, ["children", "style", "color", "variant"]);
    const { theme } = (0, Theme_1.useTheme)();
    const filteredChildren = children.filter(nil_1.notNil);
    return (react_1.default.createElement(react_native_1.View, { ref: ref, "aria-label": "button-group", style: [
            (0, native_1.css)(Object.assign({ flexDirection: 'row' }, (react_native_1.Platform.OS === 'web'
                ? {
                    width: 'fit-content',
                }
                : {
                    display: 'flex',
                    alignSelf: 'flex-start',
                }))),
            style,
        ] }, react_1.Children.map(filteredChildren, (child, index) => {
        var _a, _b, _c;
        const style = {};
        if (filteredChildren.length <= 1) {
            style.container = {};
        }
        else {
            if (index === 0) {
                style.container = {
                    borderTopRightRadius: 0,
                    borderBottomRightRadius: 0,
                    borderRightWidth: 1,
                    borderRightColor: theme.palette.primary.dark,
                };
            }
            else if (index === children.length - 1) {
                style.container = Object.assign({ borderTopLeftRadius: 0, borderBottomLeftRadius: 0 }, (filteredChildren.length > 2 && {
                    borderLeftWidth: 1,
                    borderLeftColor: theme.palette.primary.dark,
                }));
            }
            else {
                style.container = {
                    borderRadius: 0,
                };
            }
        }
        if ((0, react_1.isValidElement)(child)) {
            return Object.assign(Object.assign({}, child), { props: Object.assign(Object.assign(Object.assign({ color,
                    variant }, buttonProps), child.props), { style: Object.assign(Object.assign({}, child.props.style), { container: Object.assign(Object.assign({}, style.container), ((_c = (_b = (_a = child.props) === null || _a === void 0 ? void 0 : _a.style) === null || _b === void 0 ? void 0 : _b.container) !== null && _c !== void 0 ? _c : {})) }) }) });
        }
        return child;
    })));
});
exports.ButtonGroup.displayName = 'ButtonGroup';
