"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Calendar = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const native_1 = __importDefault(require("@emotion/native"));
const date_fns_1 = require("date-fns");
const Grid_1 = require("@procyon/components/Grid");
const Stack_1 = require("@procyon/components/Stack");
const Theme_1 = require("@procyon/styles/Theme");
const nil_1 = require("@procyon/utils/nil");
const CalendarWeek_1 = require("./CalendarWeek");
const Controls_1 = require("./Controls");
const DateSlot_1 = require("./DateSlot");
const utils_1 = require("./utils");
const WeekDays_1 = require("./WeekDays");
function Calendar({ value, onClick, onRangeChange, layout = 'month', type = 'days', weekOfMonth, ControlsView = Controls_1.Controls, DaysOfWeekView = WeekDays_1.WeekDays, title, DateSlotView = DateSlot_1.DateSlot, TimeColumn = react_1.Fragment, selectWeek, selected, style, longDayNames, }) {
    const [workDate, setWorkDate] = (0, react_1.useState)(value !== null && value !== void 0 ? value : new Date());
    const { theme } = (0, Theme_1.useTheme)();
    const handleChangeRange = () => {
        switch (layout) {
            case 'month':
                onRangeChange === null || onRangeChange === void 0 ? void 0 : onRangeChange((0, date_fns_1.startOfMonth)(workDate), (0, date_fns_1.endOfMonth)(workDate));
                return;
            case 'week':
                onRangeChange === null || onRangeChange === void 0 ? void 0 : onRangeChange((0, utils_1.getWeekRange)(workDate)[0], (0, utils_1.getWeekRange)(workDate)[1]);
                return;
            case 'day':
                onRangeChange === null || onRangeChange === void 0 ? void 0 : onRangeChange(workDate, workDate);
        }
    };
    const handleClickPrev = () => {
        switch (layout) {
            case 'month':
                if (type === 'months') {
                    setWorkDate((0, date_fns_1.sub)(workDate, { years: 1 }));
                    return;
                }
                setWorkDate((0, date_fns_1.sub)(workDate, { months: 1 }));
                return;
            case 'week':
                setWorkDate((0, date_fns_1.sub)(workDate, { weeks: 1 }));
                return;
            case 'day':
                setWorkDate((0, date_fns_1.sub)(workDate, { days: 1 }));
        }
    };
    const handleClickNext = () => {
        switch (layout) {
            case 'month':
                if (type === 'months') {
                    setWorkDate((0, date_fns_1.add)(workDate, { years: 1 }));
                    return;
                }
                setWorkDate((0, date_fns_1.add)(workDate, { months: 1 }));
                return;
            case 'week':
                setWorkDate((0, date_fns_1.add)(workDate, { weeks: 1 }));
                return;
            case 'day':
                setWorkDate((0, date_fns_1.add)(workDate, { days: 1 }));
        }
    };
    const handleClickSetToday = () => {
        setWorkDate(new Date());
    };
    const handleClick = (date) => {
        onClick === null || onClick === void 0 ? void 0 : onClick(date);
    };
    (0, react_1.useEffect)(() => {
        if (value && value !== workDate) {
            setWorkDate(value);
        }
    }, [value]);
    (0, react_1.useEffect)(() => {
        handleChangeRange();
    }, [workDate]);
    const DaysLayout = (0, react_1.useMemo)(() => {
        const end = layout === 'month' ? (0, date_fns_1.getWeeksInMonth)(workDate, { weekStartsOn: 1 }) : 1;
        return (react_1.default.createElement(Stack_1.Stack, { direction: "column", width: "100%" },
            react_1.default.createElement(DaysOfWeekView, { layout: layout, workDate: workDate, longNames: longDayNames }),
            (0, ramda_1.range)(0, end).map((i) => (react_1.default.createElement(CalendarWeek_1.CalendarWeek, { key: i, selected: selected, weekOfMonth: i, layout: layout, DateSlotView: DateSlotView, onClick: handleClick, workDate: new Date(workDate), value: value, type: type, selectWeek: selectWeek })))));
    }, [
        layout,
        selected,
        DateSlotView,
        WeekDays_1.WeekDays,
        workDate,
        value,
        type,
        longDayNames,
        selectWeek,
    ]);
    const MonthsLayout = (0, react_1.useMemo)(() => {
        return (react_1.default.createElement(Grid_1.Grid, { cols: { xs: 3 } }, (0, ramda_1.range)(0, 3).map((rowIndex) => {
            return (0, ramda_1.range)(1, 5).map((cellIndex) => {
                const month = cellIndex + 4 * rowIndex;
                return (react_1.default.createElement(DateSlotView, { key: cellIndex, date: new Date(workDate.getFullYear(), month - 1, 1), workDate: workDate, layout: layout, isSelected: (selected === null || selected === void 0 ? void 0 : selected.getMonth()) === month - 1 &&
                        workDate.getFullYear() === (selected === null || selected === void 0 ? void 0 : selected.getFullYear()), isToday: new Date().getMonth() === month - 1 &&
                        workDate.getFullYear() === new Date().getFullYear(), type: type, weekOfMonth: weekOfMonth, onClick: handleClick }, month));
            });
        })));
    }, [workDate, type, layout, onClick]);
    return (react_1.default.createElement(Stack_1.Stack, { direction: "column", gap: theme.spacing.xl },
        (0, nil_1.notNil)(title) && react_1.default.createElement(CalendarTitle, null, title),
        react_1.default.createElement(ControlsView, { layout: layout, onNextClick: handleClickNext, onPrevClick: handleClickPrev, onTodayClick: handleClickSetToday, type: type, workDate: workDate, style: style === null || style === void 0 ? void 0 : style.control }),
        react_1.default.createElement(Stack_1.Stack, { direction: "row", justifyContent: "center" },
            react_1.default.createElement(TimeColumn, null),
            type === 'days' && DaysLayout,
            type === 'months' && MonthsLayout)));
}
exports.Calendar = Calendar;
const CalendarTitle = native_1.default.Text(({ theme }) => {
    return {
        fontSize: theme.fontSize.lg,
        fontFamily: theme.fontFamily,
        marginBottom: theme.spacing.md,
    };
});
