"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controls = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const date_fns_1 = require("date-fns");
const Stack_1 = require("@procyon/components/Stack");
const Typography_1 = require("@procyon/components/Typography");
const CalendarFold_1 = require("@procyon/icons/CalendarFold");
const CircleArrowLeft_1 = require("@procyon/icons/CircleArrowLeft");
const CircleArrowRight_1 = require("@procyon/icons/CircleArrowRight");
const utils_1 = require("./utils");
const Controls = ({ layout, type, workDate, onNextClick, onPrevClick, onTodayClick, style, }) => {
    const Period = (0, react_1.useMemo)(() => {
        switch (layout) {
            case 'month':
                if (type === 'months') {
                    return (0, date_fns_1.format)(workDate, 'yyyy');
                }
                return (0, date_fns_1.format)(workDate, 'MM. yyyy');
            case 'week':
                return [
                    (0, date_fns_1.format)((0, utils_1.getWeekRange)(workDate)[0], 'dd.MM.'),
                    ' - ',
                    (0, date_fns_1.format)((0, utils_1.getWeekRange)(workDate)[1], 'dd.MM.yyyy'),
                ];
            case 'day':
                return (0, date_fns_1.format)(workDate, 'dd.MM.yyyy');
        }
    }, [workDate, layout, type]);
    return (react_1.default.createElement(Stack_1.Stack, { direction: "row", justifyContent: "space-between", alignItems: "center", style: [style === null || style === void 0 ? void 0 : style.container] },
        react_1.default.createElement(Typography_1.Typography, { size: "h2" }, Period),
        react_1.default.createElement(Stack_1.Stack, { direction: "row", gap: 12 },
            react_1.default.createElement(CalendarControlsIcon, { onPress: onPrevClick },
                react_1.default.createElement(CircleArrowLeft_1.CircleArrowLeftIcon, { fontSize: 24, strokeWidth: 1 })),
            react_1.default.createElement(CalendarControlsIcon, { onPress: onTodayClick },
                react_1.default.createElement(CalendarFold_1.CalendarFoldIcon, { fontSize: 24, strokeWidth: 1 })),
            react_1.default.createElement(CalendarControlsIcon, { onPress: onNextClick },
                react_1.default.createElement(CircleArrowRight_1.CircleArrowRightIcon, { fontSize: 24, strokeWidth: 1 })))));
};
exports.Controls = Controls;
const CalendarControlsIcon = native_1.default.Pressable(() => {
    return Object.assign({}, { cursor: 'pointer' });
});
