"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateSlot = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const date_fns_1 = require("date-fns");
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const RippleEffect_1 = require("@procyon/components/RippleEffect");
const useHover_1 = require("@procyon/hooks/useHover");
const Theme_1 = require("@procyon/styles/Theme");
const debounce_1 = require("@procyon/utils/debounce");
const DateSlot = ({ children, workDate, date, isSelected, isToday, onClick, type, style, }) => {
    const isOtherMonth = !(0, date_fns_1.isSameMonth)(workDate, date);
    const rippleAnimateRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const { hovered, onHoverIn, onHoverOut } = (0, useHover_1.useHover)();
    const { theme } = (0, Theme_1.useTheme)();
    const rippleColor = (0, react_1.useMemo)(() => {
        if (isToday || isSelected) {
            return theme.palette.primary.light;
        }
        else {
            return theme.palette.highlight.main;
        }
    }, []);
    return (react_1.default.createElement(react_native_1.Pressable, { onPress: (0, debounce_1.debounceAfter)(() => onClick === null || onClick === void 0 ? void 0 : onClick(date), 200), onHoverIn: onHoverIn, onHoverOut: onHoverOut },
        react_1.default.createElement(CalendarDateContainer, { style: style === null || style === void 0 ? void 0 : style.container, type: type, isSelected: isSelected, isOtherMonth: isOtherMonth, hovered: hovered, ref: rippleAnimateRef },
            react_1.default.createElement(RippleEffect_1.RippleEffect, { color: rippleColor, style: {
                    container: {
                        alignItems: 'center',
                        justifyContent: 'center',
                        borderRadius: theme.rounded.small,
                    },
                }, ref: rippleAnimateRef },
                react_1.default.createElement(CalendarDateText, { style: style === null || style === void 0 ? void 0 : style.container, type: type, isToday: isToday, isSelected: isSelected, isOtherMonth: isOtherMonth }, children)))));
};
exports.DateSlot = DateSlot;
const CalendarDateContainer = (0, native_1.default)(react_native_1.View)(({ theme, isSelected, hovered }) => {
    return Object.assign(Object.assign({ borderRadius: theme.rounded.small, margin: 1, padding: 2 }, (hovered && {
        borderWidth: 1,
        padding: 1,
        backgroundColor: theme.palette.highlight.light,
        borderColor: theme.palette.highlight.dark,
    })), (isSelected && {
        borderWidth: 1,
        padding: 1,
        backgroundColor: theme.palette.primary.light,
        borderColor: theme.palette.primary.dark,
    }));
});
const CalendarDateText = native_1.default.Text(({ theme, type, isSelected, isToday, isOtherMonth }) => {
    return Object.assign(Object.assign(Object.assign({ fontFamily: theme.fontFamily, fontSize: theme.fontSize.md, color: theme.palette.text.main, padding: theme.spacing.md, width: 36, textAlign: 'center' }, (isOtherMonth &&
        type !== 'months' && {
        color: theme.palette.text.light,
    })), (isToday && {
        fontWeight: 'bold',
    })), (isSelected && {
        color: theme.palette.primary.dark,
    }));
});
