"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.WeekDays = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const Grid_1 = require("@procyon/components/Grid");
const tolgee_1 = require("@procyon/localization/tolgee");
const WeekDays = ({ workDate, layout, longNames, style }) => {
    const { t } = (0, tolgee_1.useTranslate)();
    const dayOfWeek = new Date(workDate).getDay() === 0 ? 6 : new Date(workDate).getDay() - 1;
    const FULL_DAYS = [
        t('calendar.weekdays.monday'),
        t('calendar.weekdays.tuesday'),
        t('calendar.weekdays.wednesday'),
        t('calendar.weekdays.thursday'),
        t('calendar.weekdays.friday'),
        t('calendar.weekdays.saturday'),
        t('calendar.weekdays.sunday'),
    ];
    let daysInWeekNames = FULL_DAYS.map((day) => day.substring(0, 2));
    if (longNames)
        daysInWeekNames = FULL_DAYS;
    if (layout === 'day')
        daysInWeekNames = [FULL_DAYS[dayOfWeek]];
    return (react_1.default.createElement(CalendarWeekDaysContainer, { style: style === null || style === void 0 ? void 0 : style.container },
        react_1.default.createElement(Grid_1.Grid, { cols: { xs: 7 } }, daysInWeekNames.map((day) => (react_1.default.createElement(CalendarWeekDays, { key: day },
            react_1.default.createElement(CalendarWeekDay, { style: style === null || style === void 0 ? void 0 : style.day }, day)))))));
};
exports.WeekDays = WeekDays;
const CalendarWeekDaysContainer = (0, native_1.default)(react_native_1.View)(({ theme }) => {
    return {
        borderBottomWidth: 1,
        borderColor: theme.palette.primary.dark,
        padding: theme.spacing.sm,
        marginBottom: theme.spacing.sm,
    };
});
const CalendarWeekDays = (0, native_1.default)(react_native_1.View)(() => {
    return {
        alignItems: 'center',
    };
});
const CalendarWeekDay = native_1.default.Text(({ theme }) => {
    return {
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSize.md,
        fontWeight: 'bold',
        color: theme.palette.primary.dark,
    };
});
