import React from 'react';
import { StyleProp, TextStyle, ViewStyle } from 'react-native';
import { InputElementType } from '@procyon/types/form';
export type CheckboxProps<V = boolean> = Omit<{
    checked?: boolean;
    description?: string;
    labelPosition?: 'left' | 'right';
    style?: {
        container?: StyleProp<ViewStyle>;
        description?: StyleProp<TextStyle>;
        input?: StyleProp<ViewStyle>;
        slider?: StyleProp<ViewStyle>;
        switch?: StyleProp<ViewStyle>;
    };
    switch?: boolean;
} & InputElementType<V>, 'value' | 'onBlur' | 'onFocus' | 'onClick'>;
export declare const Checkbox: React.FC<CheckboxProps>;
