"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Checkbox = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
const FieldMessage_1 = require("@procyon/components/FieldMessage");
const Label_1 = require("@procyon/components/Label");
const useMediaQuery_1 = require("@procyon/styles/useMediaQuery");
const SLIDER_X = {
    sm: { left: 0, right: 8 },
    md: { left: 2, right: 21 },
    lg: { left: 2, right: 30 },
    xl: { left: 4, right: 40 },
};
const Checkbox = ({ label, description, color = 'primary', disabled, size = 'md', labelSize, labelPosition = 'right', style, message, checked, onChange, fullWidth, }) => {
    const mq = (0, useMediaQuery_1.useMediaQuery)();
    const sliderLeft = (0, react_native_reanimated_1.useSharedValue)(checked ? SLIDER_X[size].right : SLIDER_X[size].left);
    const animatedStyles = (0, react_native_reanimated_1.useAnimatedStyle)(() => {
        return {
            marginLeft: sliderLeft.value,
        };
    });
    (0, react_1.useEffect)(() => {
        sliderLeft.value = (0, react_native_reanimated_1.withTiming)(checked ? SLIDER_X[size].right : SLIDER_X[size].left);
    }, [checked]);
    const handleClick = (e) => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e, !checked);
    };
    return (react_1.default.createElement(react_native_1.View, { style: [
            {
                width: fullWidth || (fullWidth === undefined && mq === 'xs') ? '100%' : 'auto',
            },
            style === null || style === void 0 ? void 0 : style.container,
        ], "aria-label": "checkbox" },
        label && (react_1.default.createElement(Label_1.Label, { size: labelSize, disabled: disabled }, label)),
        react_1.default.createElement(CheckboxInput, { style: [style === null || style === void 0 ? void 0 : style.input], onPress: handleClick, disabled: disabled, labelPosition: labelPosition, size: size },
            react_1.default.createElement(CheckboxSwitch, { color: color, checked: checked, disabled: disabled, size: size, style: [style === null || style === void 0 ? void 0 : style.switch] },
                react_1.default.createElement(CheckboxSlider, { style: [style === null || style === void 0 ? void 0 : style.slider, animatedStyles], checked: checked, color: color, disabled: disabled, size: size })),
            react_1.default.createElement(CheckboxDescription, { style: [style === null || style === void 0 ? void 0 : style.description], disabled: disabled, size: size }, description)),
        react_1.default.createElement(FieldMessage_1.FieldMessage, { color: color, size: size, message: message })));
};
exports.Checkbox = Checkbox;
const CheckboxInput = native_1.default.Pressable(() => {
    return {
        display: 'flex',
        alignItems: 'center',
        gap: 12,
        width: 'fit-content',
    };
}, ({ theme, size }) => {
    return {
        paddingTop: theme.spacing[size] - 1,
        paddingBottom: theme.spacing[size] + 4,
    };
}, ({ labelPosition }) => {
    if (labelPosition === 'left')
        return {
            flexDirection: 'row-reverse',
        };
    else
        return { flexDirection: 'row' };
});
const CheckboxSwitch = (0, native_1.default)(react_native_1.View)(() => {
    return {
        justifyContent: 'center',
        borderRadius: 50,
        borderWidth: 1,
    };
}, ({ color, theme, checked }) => {
    return {
        borderColor: theme.palette[color].dark,
        backgroundColor: checked
            ? theme.palette[color].light
            : theme.palette.background.main,
    };
}, ({ size }) => {
    return {
        sm: { width: 20, height: 10 },
        md: { width: 40, height: 21 },
        lg: { width: 60, height: 30 },
        xl: { width: 80, height: 40 },
    }[size];
}, ({ disabled, theme }) => {
    if (disabled) {
        return {
            borderColor: theme.palette.disabled,
        };
    }
});
const CheckboxSlider = (0, native_1.default)(react_native_reanimated_1.default.View)(() => {
    return {
        borderRadius: 50,
        borderWidth: 1,
    };
}, ({ theme, color, checked }) => {
    return {
        borderWidth: checked ? 0 : 1,
        backgroundColor: checked
            ? theme.palette[color].main
            : theme.palette.background.main,
    };
}, ({ size }) => {
    return {
        sm: { width: 8, height: 8 },
        md: { width: 15, height: 15 },
        lg: { width: 24, height: 24 },
        xl: { width: 32, height: 32 },
    }[size];
}, ({ disabled, theme }) => {
    if (disabled) {
        return {
            borderColor: theme.palette.disabled,
        };
    }
});
const CheckboxDescription = native_1.default.Text(({ theme }) => {
    return {
        fontFamily: theme.fontFamily,
    };
}, ({ theme, size }) => {
    return {
        fontSize: theme.fontSize[size],
    };
}, ({ disabled, theme }) => {
    if (disabled) {
        return {
            color: theme.palette.disabled,
        };
    }
});
