"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DatePicker = exports.DEFAULT_DATE_FORMAT = void 0;
const react_1 = __importStar(require("react"));
const date_fns_1 = require("date-fns");
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const Calendar_1 = require("@procyon/components/Calendar");
const context_1 = require("@procyon/components/Modal/context");
const CalendarFold_1 = require("@procyon/icons/CalendarFold");
const Theme_1 = require("@procyon/styles/Theme");
const imask_1 = require("@procyon/utils/imask");
const TextField_1 = require("./TextField");
exports.DEFAULT_DATE_FORMAT = 'dd.MM.yyyy';
const DatePicker = (_a) => {
    var _b, _c;
    var { onChange, label, name, value } = _a, others = __rest(_a, ["onChange", "label", "name", "value"]);
    const dateFormat = (_b = others.format) !== null && _b !== void 0 ? _b : exports.DEFAULT_DATE_FORMAT;
    const formatValue = (date) => {
        if (date)
            return (0, date_fns_1.format)(date, dateFormat);
        return undefined;
    };
    const { theme } = (0, Theme_1.useTheme)();
    const viewRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const [inputValue, setInputValue] = (0, react_1.useState)(undefined);
    (0, react_1.useEffect)(() => {
        if (value) {
            setInputValue((0, date_fns_1.format)(value, exports.DEFAULT_DATE_FORMAT));
        }
    }, []);
    const [openModal, closeModal, { opened }] = (0, context_1.useModal)(name, {
        Component: ({ rootStyle }) => (react_1.default.createElement(react_native_1.View, { style: [rootStyle] },
            react_1.default.createElement(Calendar_1.Calendar, { onClick: handleDateClick, value: value, selected: value }))),
    });
    const handleChangeValue = (e, value) => {
        onChange === null || onChange === void 0 ? void 0 : onChange(e, value);
        setInputValue(formatValue(value));
    };
    const handleDateClick = (value) => {
        handleChangeValue(undefined, value);
        closeModal();
    };
    const handleOpenCalendar = () => {
        if (opened.includes(name)) {
            closeModal();
            return;
        }
        (0, react_native_reanimated_1.runOnUI)(() => {
            const layout = (0, react_native_reanimated_1.measure)(viewRef);
            (0, react_native_reanimated_1.runOnJS)(openModal)({
                props: {
                    rootStyle: Object.assign(Object.assign(Object.assign({ position: 'absolute' }, (!!(layout === null || layout === void 0 ? void 0 : layout.pageY) && { top: layout.pageY + 65 })), (!!(layout === null || layout === void 0 ? void 0 : layout.pageX) && { left: layout.pageX })), { zIndex: 7, margin: theme.spacing.sm, marginHorizontal: 0, padding: theme.spacing.lg, borderRadius: theme.rounded.small, backgroundColor: theme.palette.background.main, borderWidth: 1, borderColor: theme.palette.secondary.main }),
                },
            });
        })();
    };
    const mask = (_c = others.mask) !== null && _c !== void 0 ? _c : imask_1.IMask.createMask({
        mask: Date,
        pattern: exports.DEFAULT_DATE_FORMAT,
        blocks: {
            dd: {
                mask: imask_1.IMask.MaskedRange,
                from: 1,
                to: 31,
            },
            MM: {
                mask: imask_1.IMask.MaskedRange,
                from: 1,
                to: 12,
            },
            yyyy: {
                mask: imask_1.IMask.MaskedRange,
                from: 1900,
                to: 9999,
            },
        },
        parse: (value) => {
            return (0, date_fns_1.parse)(value, exports.DEFAULT_DATE_FORMAT, new Date());
        },
        format: (value) => {
            return (0, date_fns_1.format)(value, exports.DEFAULT_DATE_FORMAT);
        },
        autofix: true,
    });
    return (react_1.default.createElement(react_native_1.View, { ref: viewRef },
        react_1.default.createElement(TextField_1.TextField, Object.assign({ name: name, label: label, placeholder: dateFormat, LeftIcon: (props) => (react_1.default.createElement(react_native_1.View, { style: [react_native_1.Platform.OS === 'web' && { cursor: 'pointer' }] },
                react_1.default.createElement(CalendarFold_1.CalendarFoldIcon, Object.assign({}, props, { onClick: () => handleOpenCalendar() })))) }, others, { mask: mask, value: inputValue !== null && inputValue !== void 0 ? inputValue : '', onChange: (e, value) => {
                if (mask.isComplete) {
                    handleChangeValue(e, (0, date_fns_1.parse)(mask.value, dateFormat, new Date()));
                }
                setInputValue(value !== null && value !== void 0 ? value : undefined);
            } }))));
};
exports.DatePicker = DatePicker;
