"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Grid = void 0;
const react_1 = __importStar(require("react"));
const ramda_1 = require("ramda");
const react_native_1 = require("react-native");
const useMediaQuery_1 = require("@procyon/styles/useMediaQuery");
const Grid = (_a) => {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
    var { children, cols, gap = 0, layout, style } = _a, props = __rest(_a, ["children", "cols", "gap", "layout", "style"]);
    const mq = (0, useMediaQuery_1.useMediaQuery)();
    if (!mq) {
        return null;
    }
    let itemIndex = -1;
    const isMobile = mq === 'xs';
    const childrenInArray = react_1.Children.toArray(children);
    const defaultColCount = 1;
    const colCount = isMobile
        ? (_b = cols === null || cols === void 0 ? void 0 : cols.xs) !== null && _b !== void 0 ? _b : defaultColCount
        : (_g = (_f = (_e = (_d = (_c = cols === null || cols === void 0 ? void 0 : cols[mq]) !== null && _c !== void 0 ? _c : cols === null || cols === void 0 ? void 0 : cols.xl) !== null && _d !== void 0 ? _d : cols === null || cols === void 0 ? void 0 : cols.lg) !== null && _e !== void 0 ? _e : cols === null || cols === void 0 ? void 0 : cols.md) !== null && _f !== void 0 ? _f : cols === null || cols === void 0 ? void 0 : cols.sm) !== null && _g !== void 0 ? _g : childrenInArray.length;
    const defaultLayout = new Array(childrenInArray.length).fill(1);
    const activeLayout = isMobile
        ? (_h = layout === null || layout === void 0 ? void 0 : layout.xs) !== null && _h !== void 0 ? _h : defaultLayout
        : (_o = (_m = (_l = (_k = (_j = layout === null || layout === void 0 ? void 0 : layout[mq]) !== null && _j !== void 0 ? _j : layout === null || layout === void 0 ? void 0 : layout.xl) !== null && _k !== void 0 ? _k : layout === null || layout === void 0 ? void 0 : layout.lg) !== null && _l !== void 0 ? _l : layout === null || layout === void 0 ? void 0 : layout.md) !== null && _m !== void 0 ? _m : layout === null || layout === void 0 ? void 0 : layout.sm) !== null && _o !== void 0 ? _o : defaultLayout;
    const chunks = splitIntoChunks(childrenInArray, colCount, activeLayout);
    return chunks.map((chunk, chunkIndex) => {
        const emptyColsArray = new Array(colCount - chunk.length).fill(0);
        return (react_1.default.createElement(react_native_1.Pressable, Object.assign({ key: chunkIndex, style: [{ display: 'flex', flexDirection: 'column' }] }, props),
            react_1.default.createElement(react_native_1.View, { style: [
                    {
                        display: 'flex',
                        flexDirection: 'row',
                        cursor: 'auto',
                        flex: 1,
                    },
                    style === null || style === void 0 ? void 0 : style.row,
                ] },
                chunk.map((child, childIndex) => {
                    itemIndex++;
                    const itemLayout = activeLayout.at(itemIndex);
                    const span = typeof itemLayout === 'string' ? 1 : itemLayout !== null && itemLayout !== void 0 ? itemLayout : 1;
                    (0, ramda_1.range)(0, span - 1).forEach(() => {
                        emptyColsArray.pop();
                    });
                    return (react_1.default.createElement(react_native_1.View, { key: childIndex, style: [
                            {
                                flexGrow: isMobile ? 1 : typeof itemLayout === 'string' ? 0 : span,
                                flexBasis: isMobile
                                    ? 'auto'
                                    : typeof itemLayout === 'string'
                                        ? itemLayout
                                        : 1,
                            },
                            style === null || style === void 0 ? void 0 : style.cell,
                        ] },
                        react_1.default.createElement(react_native_1.View, { style: { marginRight: childIndex !== chunk.length - 1 ? gap : 0 } }, child)));
                }),
                emptyColsArray.map((n, i) => (react_1.default.createElement(react_native_1.View, { style: { flex: 1 }, key: i }))))));
    });
};
exports.Grid = Grid;
function splitIntoChunks(array, colCount, layout) {
    const result = [];
    let chunk = [];
    let counter = 0;
    for (let i = 0; i < array.length; i++) {
        const item = array[i];
        const itemSize = typeof layout[i] === 'string' ? 1 : layout[i];
        if (counter + itemSize > colCount) {
            result.push(chunk);
            chunk = [item];
            counter = itemSize;
        }
        else {
            chunk.push(item);
            counter += itemSize;
        }
        if (counter === colCount) {
            result.push(chunk);
            chunk = [];
            counter = 0;
        }
    }
    if (chunk.length) {
        result.push(chunk);
    }
    return result;
}
