"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MenuItem = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const RippleEffect_1 = require("@procyon/components/RippleEffect");
const ExternalLink_1 = require("@procyon/icons/ExternalLink");
const Theme_1 = require("@procyon/styles/Theme");
const MenuItem = (_a) => {
    var _b, _c;
    var { onNav, Icon } = _a, item = __rest(_a, ["onNav", "Icon"]);
    const { theme } = (0, Theme_1.useTheme)();
    const rippleAnimationRef = (0, react_native_reanimated_1.useAnimatedRef)();
    return (react_1.default.createElement(MenuItemContainer, { side: item.side, style: [(_b = item.style) === null || _b === void 0 ? void 0 : _b.container], active: item.active, onPress: () => onNav === null || onNav === void 0 ? void 0 : onNav(item), ref: rippleAnimationRef },
        react_1.default.createElement(RippleEffect_1.RippleEffect, { ref: rippleAnimationRef, style: {
                container: {
                    display: 'flex',
                    flexDirection: 'row',
                    alignItems: 'center',
                    gap: 2,
                    borderRadius: theme.spacing.md,
                    padding: theme.spacing.md,
                },
            }, color: item.active
                ? theme.palette[item.side ? 'secondary' : 'primary'].light
                : theme.palette[item.side ? 'secondary' : 'primary'].dark },
            item.side && !Icon ? (react_1.default.createElement(react_native_1.View, { style: { width: theme.fontSize.md } })) : (Icon && react_1.default.createElement(Icon, { size: theme.fontSize.md })),
            react_1.default.createElement(MenuItemText, { side: item.side, style: [(_c = item.style) === null || _c === void 0 ? void 0 : _c.text], active: item.active }, item.children),
            item.external && react_1.default.createElement(ExternalLink_1.ExternalLinkIcon, { size: theme.fontSize.md, strokeWidth: 1 }))));
};
exports.MenuItem = MenuItem;
const MenuItemContainer = native_1.default.Pressable(({ theme, active, side }) => {
    return {
        borderRadius: theme.spacing.md,
        backgroundColor: active
            ? theme.palette[side ? 'secondary' : 'primary'].dark
            : 'transparent',
        color: active ? theme.palette.primary.light : theme.palette.primary.dark,
    };
});
const MenuItemText = native_1.default.Text(({ theme, active, side }) => {
    return {
        fontFamily: theme.fontFamily,
        fontSize: theme.fontSize.md,
        color: active
            ? theme.palette[side ? 'secondary' : 'primary'].light
            : theme.palette[side ? 'secondary' : 'primary'].dark,
    };
});
