"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalTitle = exports.ModalContainer = exports.Modals = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const values_js_1 = __importDefault(require("values.js"));
const nil_1 = require("@procyon/utils/nil");
const context_1 = require("./context");
const Modals = () => {
    const [, , { modals, opened, closeModal, rootRef }] = (0, context_1.useModal)();
    const handleCloseModal = (modalId) => {
        var _a, _b, _c;
        (_c = (_b = (_a = modals[modalId]) === null || _a === void 0 ? void 0 : _a.props) === null || _b === void 0 ? void 0 : _b.onClose) === null || _c === void 0 ? void 0 : _c.call(_b);
        closeModal(modalId);
    };
    const handleKeyUp = (e) => {
        if (e.key === 'Escape') {
            const modalId = opened.at(-1);
            if (modalId !== undefined) {
                handleCloseModal(modalId);
            }
        }
    };
    (0, react_1.useEffect)(() => {
        if (react_native_1.Platform.OS === 'web') {
            window.addEventListener('keydown', handleKeyUp);
            return () => {
                window.removeEventListener('keydown', handleKeyUp);
            };
        }
    }, [opened]);
    if (!(0, nil_1.notNil)(opened)) {
        return null;
    }
    return opened.map((modalId) => {
        var _a;
        const { id, style, Component = react_native_1.View, props } = (_a = modals[modalId]) !== null && _a !== void 0 ? _a : {};
        if (!id)
            return null;
        return (react_1.default.createElement(react_native_1.Modal, { transparent: true, visible: true, key: id, ref: rootRef },
            react_1.default.createElement(ModalOverflow, { style: [style === null || style === void 0 ? void 0 : style.overflow], onPressIn: () => handleCloseModal(id) }),
            react_1.default.createElement(Component, Object.assign({}, props))));
    });
};
exports.Modals = Modals;
const ModalOverflow = (0, native_1.default)(react_native_1.Pressable)(({ theme }) => {
    return Object.assign(Object.assign({}, (react_native_1.Platform.OS === 'web' && { cursor: 'close' })), { position: 'absolute', top: 0, right: 0, bottom: 0, left: 0, zIndex: 6, backgroundColor: `${new values_js_1.default(theme.palette.background.dark).hexString()}80` });
});
exports.ModalContainer = (0, native_1.default)(react_native_1.Pressable)(({ theme }) => {
    return {
        width: 200,
        marginLeft: 'auto',
        marginRight: 'auto',
        marginTop: 'auto',
        marginBottom: 'auto',
        zIndex: 7,
        padding: theme.spacing.lg,
        backgroundColor: theme.palette.background.main,
        borderRadius: theme.spacing.md,
    };
});
exports.ModalTitle = (0, native_1.default)(react_native_1.Text)(({ theme }) => {
    return {
        fontSize: theme.fontSize.lg,
        fontFamily: theme.fontFamily,
        borderBottomWidth: 1,
        borderBottomColor: theme.palette.primary.dark,
        paddingHorizontal: theme.spacing.md,
        paddingBottom: theme.spacing.md,
        marginBottom: 10,
    };
});
