"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RadioButton = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const Label_1 = require("@procyon/components/Label");
const RadioItem_1 = require("@procyon/components/RadioItem");
const useMediaQuery_1 = require("@procyon/styles/useMediaQuery");
const FieldMessage_1 = require("./FieldMessage");
const findRadioItems = (children) => {
    return react_1.Children.map(react_1.Children.toArray(children), (child) => {
        const elementChild = child;
        if ((0, react_1.isValidElement)(elementChild)) {
            if (elementChild.type === RadioItem_1.RadioItem) {
                return elementChild;
            }
            else {
                return findRadioItems(elementChild.props.children);
            }
        }
        return null;
    });
};
const RadioButton = (_a) => {
    var { disabled, label, size, labelSize, color = 'primary', value, horizontal, message, children, fullWidth } = _a, props = __rest(_a, ["disabled", "label", "size", "labelSize", "color", "value", "horizontal", "message", "children", "fullWidth"]);
    const mq = (0, useMediaQuery_1.useMediaQuery)();
    const radioItems = (0, react_1.useMemo)(() => findRadioItems(children), [children]);
    return (react_1.default.createElement(react_native_1.View, { style: [
            {
                width: fullWidth || (fullWidth === undefined && mq === 'xs') ? '100%' : 'auto',
            },
        ], "aria-label": "radio-button" },
        label && (react_1.default.createElement(Label_1.Label, { disabled: disabled, size: labelSize }, label)),
        react_1.default.createElement(RadioButtonOptions, { horizontal: horizontal }, react_1.Children.map(radioItems, (child, index) => {
            if ((0, react_1.isValidElement)(child) && child.type === RadioItem_1.RadioItem) {
                return Object.assign(Object.assign({}, child), { props: Object.assign(Object.assign(Object.assign({ color,
                        size }, props), child.props), { selected: child.props.value === value, disabled: disabled || child.props.disabled, style: {
                            container: Object.assign({}, (index === react_1.Children.count(children) - 1 && {
                                borderWidth: 0,
                            })),
                        } }) });
            }
            return child;
        })),
        react_1.default.createElement(FieldMessage_1.FieldMessage, { message: message, size: size, color: color })));
};
exports.RadioButton = RadioButton;
const RadioButtonOptions = (0, native_1.default)(react_native_1.View)(({ theme, horizontal }) => {
    return Object.assign({ display: 'flex', flexDirection: 'column', gap: theme.spacing.sm, marginTop: theme.spacing.md - 1 }, (horizontal && {
        flexDirection: 'row',
        gap: theme.spacing.xl,
    }));
});
