"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldText = exports.Selectbox = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = require("react-native-reanimated");
const List_1 = require("@procyon/components/List");
const context_1 = require("@procyon/components/Modal/context");
const ChevronDown_1 = require("@procyon/icons/ChevronDown");
const TextField_1 = require("./TextField");
const Selectbox = (props) => {
    const { value, onChange, label, message, name, data, Input = DefaultInput, Item, getLabel, style } = props, others = __rest(props, ["value", "onChange", "label", "message", "name", "data", "Input", "Item", "getLabel", "style"]);
    const viewRef = (0, react_native_reanimated_1.useAnimatedRef)();
    const longestLabelLength = (0, react_1.useMemo)(() => {
        const lengths = [];
        data === null || data === void 0 ? void 0 : data.forEach((item) => {
            var _a;
            const label = (_a = item === null || item === void 0 ? void 0 : item.label) !== null && _a !== void 0 ? _a : getLabel(item);
            lengths.push(label.length);
        });
        return Math.max(...lengths);
    }, [data]);
    const [openModal, closeModal, { opened }] = (0, context_1.useModal)(name, {
        Component: ({ rootStyle }) => {
            var _a, _b;
            return (react_1.default.createElement(react_native_1.View, { style: [rootStyle] },
                react_1.default.createElement(List_1.List, { Item: Item, selected: value, data: data, getLabel: getLabel, onClick: (event, id) => {
                        event.preventDefault();
                        onChange === null || onChange === void 0 ? void 0 : onChange(event, id);
                        closeModal();
                    }, style: {
                        container: [
                            {
                                marginHorizontal: 0,
                                marginBottom: 10,
                            },
                            (_a = style === null || style === void 0 ? void 0 : style.list) === null || _a === void 0 ? void 0 : _a.container,
                        ],
                        list: [
                            {
                                maxHeight: 300,
                            },
                            (_b = style === null || style === void 0 ? void 0 : style.list) === null || _b === void 0 ? void 0 : _b.list,
                        ],
                    } })));
        },
    });
    const handleOpenOptions = () => {
        if (opened.includes(name)) {
            closeModal();
            return;
        }
        (0, react_native_reanimated_1.runOnUI)(() => {
            const layout = (0, react_native_reanimated_1.measure)(viewRef);
            (0, react_native_reanimated_1.runOnJS)(openModal)({
                props: {
                    rootStyle: Object.assign(Object.assign(Object.assign(Object.assign({ position: 'absolute' }, (!!(layout === null || layout === void 0 ? void 0 : layout.width) && { width: layout.width })), (!!(layout === null || layout === void 0 ? void 0 : layout.pageY) && { top: layout.pageY + 65 })), (!!(layout === null || layout === void 0 ? void 0 : layout.pageX) && { left: layout.pageX })), { zIndex: 7 }),
                },
            });
        })();
    };
    const width = Math.min(300, longestLabelLength * 8 + 60);
    return (react_1.default.createElement(react_native_1.View, { style: [{ position: 'relative', minWidth: width }, style === null || style === void 0 ? void 0 : style.container], ref: viewRef },
        react_1.default.createElement(TextField_1.TextField, Object.assign({}, others, { style: {
                wrapper: {
                    columnGap: 0,
                },
            }, label: label, onBlur: (e) => {
                var _a;
                (_a = others.onBlur) === null || _a === void 0 ? void 0 : _a.call(others, e, value);
            }, onFocus: (e) => {
                var _a;
                (_a = others.onFocus) === null || _a === void 0 ? void 0 : _a.call(others, e, value);
            }, Input: (props) => {
                var _a;
                return (react_1.default.createElement(Input, Object.assign({}, props, { style: Object.assign(Object.assign({}, style === null || style === void 0 ? void 0 : style.input), { input: [(_a = style === null || style === void 0 ? void 0 : style.input) === null || _a === void 0 ? void 0 : _a.input, { paddingHorizontal: 10 }] }), data: data, getLabel: getLabel, value: value === null || value === void 0 ? void 0 : value.toString() })));
            }, message: message, onClick: handleOpenOptions, RightIcon: (props) => (react_1.default.createElement(react_native_1.Pressable, { onPressIn: handleOpenOptions, style: [react_native_1.Platform.OS === 'web' && { cursor: 'pointer' }] },
                react_1.default.createElement(ChevronDown_1.ChevronDownIcon, Object.assign({}, props)))) }))));
};
exports.Selectbox = Selectbox;
const DefaultInput = ({ value, data, getLabel, }) => {
    const item = data === null || data === void 0 ? void 0 : data.find((item) => item.id.toString() === value && !!value);
    if (!item)
        return null;
    return react_1.default.createElement(exports.FieldText, null, getLabel ? getLabel(item) : item.label);
};
exports.FieldText = (0, native_1.default)(react_native_1.Text)(({ theme, size = 'md' }) => {
    return Object.assign(Object.assign({}, (react_native_1.Platform.OS === 'web' && { cursor: 'pointer' })), { color: theme.palette.text.main, fontFamily: theme.fontFamily, fontSize: theme.fontSize[size] });
});
