"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Skeleton = void 0;
const react_1 = __importStar(require("react"));
const react_native_1 = require("react-native");
const react_native_reanimated_1 = __importStar(require("react-native-reanimated"));
const Theme_1 = require("@procyon/styles/Theme");
const Skeleton = ({ active, children, layout, style }) => {
    const { theme } = (0, Theme_1.useTheme)();
    const opacity = (0, react_native_reanimated_1.useSharedValue)(1);
    const animatedStyle = (0, react_native_reanimated_1.useAnimatedStyle)(() => {
        return {
            opacity: opacity.value,
        };
    }, [opacity]);
    (0, react_1.useEffect)(() => {
        opacity.value = (0, react_native_reanimated_1.withRepeat)((0, react_native_reanimated_1.withSequence)((0, react_native_reanimated_1.withTiming)(0.4, {
            duration: 2000,
        }), (0, react_native_reanimated_1.withTiming)(1, {
            duration: 2000,
        })), Infinity, true);
    }, []);
    if (!active) {
        return children;
    }
    return (react_1.default.createElement(react_native_1.View, { style: [{ width: '100%' }, style === null || style === void 0 ? void 0 : style.container] }, layout.map((_a) => {
        var { key } = _a, style = __rest(_a, ["key"]);
        return (react_1.default.createElement(react_native_reanimated_1.default.View, { key: key, style: [
                Object.assign({ backgroundColor: theme.palette.secondary.light, borderRadius: theme.spacing.md }, style),
                animatedStyle,
            ] }));
    })));
};
exports.Skeleton = Skeleton;
