"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableText = exports.TableCell = exports.TableHead = exports.useTable = exports.Table = void 0;
const react_1 = __importStar(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const Stack_1 = require("@procyon/components/Stack");
const TableContext = (0, react_1.createContext)(undefined);
const Table = ({ cols, layout, hoverable = false, children }) => {
    const childCount = react_1.default.Children.count(children);
    return (react_1.default.createElement(TableContext.Provider, { value: { cols, layout, hoverable } },
        react_1.default.createElement(TableContainer, { direction: "column" }, react_1.Children.map(children, (child, i) => {
            if (i === childCount - 1) {
                if ((0, react_1.isValidElement)(child)) {
                    return Object.assign(Object.assign({}, child), { props: Object.assign(Object.assign({}, child.props), { last: true }) });
                }
            }
            return child;
        }))));
};
exports.Table = Table;
const useTable = () => {
    const context = (0, react_1.useContext)(TableContext);
    if (!context) {
        throw new Error('useTable must be used within a TableProvider!');
    }
    return context;
};
exports.useTable = useTable;
const TableContainer = (0, native_1.default)(Stack_1.Stack)(({ theme }) => {
    return {
        borderRadius: theme.rounded.small,
    };
});
exports.TableHead = (0, native_1.default)(react_native_1.View)(({ theme }) => {
    return {
        justifyContent: 'center',
        padding: theme.spacing.md,
    };
});
exports.TableCell = (0, native_1.default)(react_native_1.View)(({ theme }) => {
    return {
        justifyContent: 'center',
        padding: theme.spacing.md,
    };
});
exports.TableText = (0, native_1.default)(react_native_1.Text)(({ theme, head }) => {
    return Object.assign({ fontFamily: theme.fontFamily, fontSize: theme.fontSize.md }, (head
        ? {
            color: theme.palette.secondary.light,
        }
        : {
            color: theme.palette.text.main,
        }));
});
