"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TableRow = void 0;
const react_1 = __importStar(require("react"));
const Grid_1 = require("@procyon/components/Grid");
const Table_1 = require("@procyon/components/Table");
const useHover_1 = require("@procyon/hooks/useHover");
const Theme_1 = require("@procyon/styles/Theme");
const TableRow = (_a) => {
    var { children, head, row, last, style } = _a, props = __rest(_a, ["children", "head", "row", "last", "style"]);
    const { theme } = (0, Theme_1.useTheme)();
    const { cols, layout, hoverable } = (0, Table_1.useTable)();
    const { hovered, onHoverIn, onHoverOut } = (0, useHover_1.useHover)();
    const defaultLayout = { sm: new Array(react_1.Children.count(children)).fill(1) };
    const defaultCols = { sm: react_1.Children.count(children) };
    return (react_1.default.createElement(Grid_1.Grid, Object.assign({ cols: cols !== null && cols !== void 0 ? cols : defaultCols, layout: layout !== null && layout !== void 0 ? layout : defaultLayout }, (hoverable && {
        onHoverIn,
        onHoverOut,
    }), props, { style: Object.assign(Object.assign(Object.assign({}, (head && {
            row: [
                {
                    backgroundColor: theme.palette.secondary.dark,
                    borderTopLeftRadius: theme.rounded.small,
                    borderTopRightRadius: theme.rounded.small,
                },
                style === null || style === void 0 ? void 0 : style.row,
            ],
        })), (row && {
            row: [
                Object.assign(Object.assign({ borderWidth: 1, borderTopWidth: 0, borderColor: theme.palette.secondary.main }, (hovered && {
                    backgroundColor: theme.palette.secondary.light,
                })), (last && {
                    borderBottomWidth: 1,
                    borderBottomLeftRadius: theme.rounded.small,
                    borderBottomRightRadius: theme.rounded.small,
                })),
                style === null || style === void 0 ? void 0 : style.row,
            ],
        })), { cell: [{ justifyContent: 'center' }, style === null || style === void 0 ? void 0 : style.cell] }) }), children));
};
exports.TableRow = TableRow;
