"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimePicker = void 0;
const react_1 = __importStar(require("react"));
const date_fns_1 = require("date-fns");
const format_1 = require("date-fns/format");
const imask_1 = require("@procyon/utils/imask");
const TextField_1 = require("./TextField");
const DEFAULT_TIME_FORMAT = 'HH:mm';
const TimePicker = (_a) => {
    var _b, _c, _d, _e, _f;
    var { onChange, label, name, hour, minute, value } = _a, others = __rest(_a, ["onChange", "label", "name", "hour", "minute", "value"]);
    const [inputValue, setInputValue] = (0, react_1.useState)(undefined);
    (0, react_1.useEffect)(() => {
        if (value) {
            setInputValue((0, date_fns_1.isDate)(value) ? (0, format_1.format)(value, DEFAULT_TIME_FORMAT) : value);
        }
    }, []);
    const mask = (_b = others.mask) !== null && _b !== void 0 ? _b : imask_1.IMask.createMask({
        mask: Date,
        pattern: DEFAULT_TIME_FORMAT,
        blocks: {
            HH: {
                mask: imask_1.IMask.MaskedRange,
                from: (_c = hour === null || hour === void 0 ? void 0 : hour.min) !== null && _c !== void 0 ? _c : 0,
                to: (_d = hour === null || hour === void 0 ? void 0 : hour.max) !== null && _d !== void 0 ? _d : 23,
            },
            mm: {
                mask: imask_1.IMask.MaskedRange,
                from: (_e = minute === null || minute === void 0 ? void 0 : minute.min) !== null && _e !== void 0 ? _e : 0,
                to: (_f = minute === null || minute === void 0 ? void 0 : minute.max) !== null && _f !== void 0 ? _f : 59,
            },
        },
        parse: (value) => {
            return (0, date_fns_1.parse)(value, DEFAULT_TIME_FORMAT, new Date());
        },
        format: (value) => {
            return (0, date_fns_1.format)(value, DEFAULT_TIME_FORMAT);
        },
        autofix: true,
    });
    return (react_1.default.createElement(TextField_1.TextField, Object.assign({ name: name, label: label, placeholder: DEFAULT_TIME_FORMAT, mode: "numeric" }, others, { mask: mask, value: inputValue, onChange: (e, newValue) => {
            if (mask.isComplete && !!onChange) {
                let changed = value !== null && value !== void 0 ? value : new Date();
                changed = (0, date_fns_1.setHours)(changed, parseInt(mask.value.split(':')[0]));
                changed = (0, date_fns_1.setMinutes)(changed, parseInt(mask.value.split(':')[1]));
                changed = (0, date_fns_1.setSeconds)(changed, 0);
                onChange(e, changed);
            }
            setInputValue(newValue !== null && newValue !== void 0 ? newValue : undefined);
        } })));
};
exports.TimePicker = TimePicker;
