"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Toasters = void 0;
const react_1 = __importDefault(require("react"));
const native_1 = __importDefault(require("@emotion/native"));
const react_native_1 = require("react-native");
const nil_1 = require("@procyon/utils/nil");
const Alert_1 = require("../Alert");
const context_1 = require("./context");
const Toasters = ({ position }) => {
    const { toasters } = (0, context_1.useToaster)();
    if (!(0, nil_1.notNil)(toasters)) {
        return null;
    }
    return (react_1.default.createElement(ToastersContainer, { position: position }, Object.keys(toasters).map((toasterId) => {
        const toaster = toasters[toasterId];
        return (react_1.default.createElement(Alert_1.Alert, { key: toasterId, color: toaster.color, title: toaster.title }, toaster.message));
    })));
};
exports.Toasters = Toasters;
const ToastersContainer = (0, native_1.default)(react_native_1.View)(() => {
    return {
        position: 'absolute',
    };
}, ({ position }) => {
    switch (position) {
        case 'topLeft':
            return {
                top: 5,
                left: 5,
            };
        case 'topCenter':
            return {
                top: 5,
                left: '50%',
                transform: [
                    {
                        translateX: '-50%',
                        translateY: '0',
                    },
                ],
            };
        case 'topRight':
            return {
                top: 5,
                right: 5,
            };
        case 'bottomLeft':
            return {
                bottom: 5,
                left: 5,
            };
        case 'bottomCenter':
            return {
                bottom: 5,
                left: '50%',
                transform: [
                    {
                        translateX: '-50%',
                        translateY: '0',
                    },
                ],
            };
        case 'bottomRight':
            return {
                bottom: 5,
                right: 5,
            };
        case 'rightCenter': {
            return {
                top: '50%',
                transform: [
                    {
                        translateY: '-50%',
                        translateX: '0',
                    },
                ],
                right: 5,
            };
        }
        case 'leftCenter': {
            return {
                top: '50%',
                transform: [
                    {
                        translateY: '-50%',
                        translateX: '0',
                    },
                ],
                left: 5,
            };
        }
        default: {
            return {};
        }
    }
});
